__kernel void %KERNEL_NAME%(__global read_only int *srcx, __global read_only int *srcy, __global int *srcm) {
  int x = get_global_id(0), y = get_global_id(1), p0 = (y << %SHIFT%) + x;

  int x2 = 1, y2 = 1, sx = srcx[p0], sy = srcy[p0];

  if (sx < 0) { sx = -sx; x2 = -1; }
  if (sy < 0) { sy = -sy; y2 = -1; }
  sx = max(sx, 1);

  if ((sy << 8) < 106 * sx) y2 = 0;
  if ((sy << 8) > 617 * sx) x2 = 0;

  int p1 = ((y + y2) << %SHIFT%) + x + x2;
  int p2 = ((y - y2) << %SHIFT%) + x - x2;
  int p3 = ((y + y2) << %SHIFT%) + x - x2;
  int p4 = ((y - y2) << %SHIFT%) + x + x2;

  bool sn  = (srcx[p0] * srcx[p1] + srcy[p0] * srcy[p1]) > 0;
  bool ss  = (srcx[p0] * srcx[p2] + srcy[p0] * srcy[p2]) > 0;
  bool sew = (srcx[p3] * srcx[p4] + srcy[p3] * srcy[p4]) > 0;

  int m = 512;
  if (x2 != 0 && y2 != 0) m = 1024;
  if ( sn && !ss & sew) m = 128;
  if (!sn &&  ss & sew) m = 1024;
  if (            !sew) m = 1024;

  int m0 = srcm[p0];
  int m1 = srcm[p1];
  int m2 = srcm[p2];
  int a0 = m0 * m;
  int a1 = m1 << 8;
  int a2 = m2 << 8;

  if (a1 > a0 && m1 >= m2) {
    atomic_add(&srcm[p1], m0);
    atomic_sub(&srcm[p0], m0);
  } else if (a2 > a0 && m2 >= m1) {
    atomic_add(&srcm[p2], m0);
    atomic_sub(&srcm[p0], m0);
  }

  /*
  bool b0 = a1 > a0 && m1 >= m2;
  bool b1 = a2 > a0 && m2 >= m1;

  if (b0 || b1) {
    if (b0) p2 = p1;
    atomic_add(&srcm[p2], m0);
    atomic_sub(&srcm[p0], m0);
  }
  */
}
